'
' Interface to a 74HC595 serial to parallel shift register
'
    Include "SPI.inc"                           ' Load the SPI peripheral macros into the program

    $define SR74_LAT PORTC.0                    ' Connects to the 74HC595 ST_CP (latch) pin.
'
' Create a variable to work with
'
    Dim bPattern As Byte                        ' The byte to output via the shift register
'-------------------------------------------------------------------------------------------
' The main demo program loop starts here
'
Main:
    Low SR74_LAT                                 ' Lock the ST_CP (Latch) line
'
' Open the SPI peripheral:
'                           Fosc/16 (4MHz operation)
'                           SPI mode 0:0
'                           Sample at the end of the clock
    OpenSPI(SPI_FOSC_16, MODE_00, SMPEND)

    bPattern = %00000001                        ' Initialise the byte to send
    While 1 = 1                                 ' Create an infinite loop
        '
        ' Cycle the outputs from Q0 to Q7
        '
        While 1 = 1                             ' Create a loop
            WriteSPI(bPattern)                  ' Shift out the byte to the 74HC595
            Set SR74_LAT                        ' Open the Latch so the value is transfered to the outputs
            DelayCS 1                           ' Wait 1 cycle
            Clear SR74_LAT                      ' Close the latch, locking the value on the output
            bPattern = bPattern << 1            ' Move the pattern one bit to the left
            If bPattern = %10000000 Then Break  ' Exit the loop when we reach the last bit
            DelayMS 100                         ' Delay so we can see what's going on
        Wend
        DelayMS 100
        '
        ' Cycle the outputs from Q7 to Q0
        '
        While 1 = 1
            WriteSPI(bPattern)                  ' Shift out the byte to the 74HC595
            Set SR74_LAT                        ' Open the Latch so the value is transfered to the outputs
            DelayCS 1                           ' Wait 1 cycle
            Clear SR74_LAT                      ' Close the latch, locking the value on the output
            bPattern = bPattern >> 1            ' Move the pattern one bit to the right
            If bPattern = %00000001 Then Break  ' Exit the loop when we reach the fist bit
            DelayMS 100                         ' Delay so we can see what's going on
        Wend
        DelayMS 100
    Wend                                        ' Do it forever
